function twowires

c=3*10^8;

Ce_a=(0.468*1e-12)*8.854;
Co_a=(1.035*1e-12)*8.854;

Zce=1/(c*Ce_a);
%Zce

Zco=1/(c*Co_a);
%Zco


s=0.010;
rw=0.0005;

%Codd=(pi*8.854*1e-12)/log(s/rw);
%Codd
%Co_a


%Coupler
l=0.200;        %length
Z0=50;



%Microstrip coupler MWO W=3 G=1 H=1.57 er=1.0 t=17um
%
%test only 
%Zce=105.1;
%Zco=69.0;


%Coupled lines

Zce=567.8;
Zco=359.0;


fmin=5*1e6;
fmax=1500*1e6;
%Np=101;
Np=300;
ff=linspace(fmin,fmax,Np);

for ii=1:Np
f=ff(ii);
la=c/f;

S=sin(2*pi*l/la);
C=cos(2*pi*l/la);
la=c/f;
S11a=0.5*j*(Zce/Z0-Z0/Zce)*S/(2*C+j*(Zce/Z0+Z0/Zce)*S);
S11b=0.5*j*(Zco/Z0-Z0/Zce)*S/(2*C+j*(Zco/Z0+Z0/Zco)*S);

mxS11(ii)=1*S11a+1*S11b;                                %OK
mxS22(ii)=1*S11a+1*S11b;
mxS33(ii)=1*S11a+1*S11b;
mxS44(ii)=1*S11a+1*S11b;

S21a=1/(2*C+j*(Zce/Z0+Z0/Zce)*S);
S21b=1/(2*C+j*(Zco/Z0+Z0/Zco)*S);

mxS21(ii)=1*S21a+1*S21b;                                %OK
mxS12(ii)=mxS21(ii);
mxS43(ii)=mxS21(ii);
mxS34(ii)=mxS21(ii);

S41a=1/(2*C+j*(Zce/Z0+Z0/Zce)*S);
S41b=1/(2*C+j*(Zco/Z0+Z0/Zco)*S);

mxS41(ii)=S41a-S41b;                                %OK
mxS14(ii)=mxS41(ii);
mxS32(ii)=mxS41(ii);
mxS23(ii)=mxS41(ii);

S42a=0.5*(j*(Zce/Z0-Z0/Zce)*S)/(2*C+j*(Zce/Z0+Z0/Zce)*S);
S42b=-0.5*(j*(Zco/Z0-Z0/Zco)*S)/(2*C+j*(Zco/Z0+Z0/Zco)*S);

mxS42(ii)=1*S42a+1*S42b;                                %OK
mxS24(ii)=mxS42(ii);
mxS31(ii)=mxS42(ii);
mxS13(ii)=mxS42(ii);

end;


%figure(1);clf;
%plot(ff,abs(mxS11));

%figure(2);clf;
%plot(ff,angle(mxS11)*180/pi);

%figure(1);clf;
%plot(ff,abs(mxS42));

%figure(2);clf;
%plot(ff,angle(mxS42)*180/pi);

for ii=1:Np

mxS(1,1,ii)=mxS11(ii);
mxS(2,2,ii)=mxS22(ii);
mxS(3,3,ii)=mxS33(ii);
mxS(4,4,ii)=mxS44(ii);

mxS(1,2,ii)=mxS12(ii);
mxS(2,1,ii)=mxS21(ii);
mxS(3,1,ii)=mxS31(ii);
mxS(1,3,ii)=mxS13(ii);
mxS(4,1,ii)=mxS41(ii);
mxS(1,4,ii)=mxS14(ii);

mxS(3,2,ii)=mxS32(ii);
mxS(2,3,ii)=mxS23(ii);
mxS(4,2,ii)=mxS42(ii);
mxS(2,4,ii)=mxS24(ii);

mxS(4,3,ii)=mxS43(ii);
mxS(3,4,ii)=mxS34(ii);

end;

mxSdB=20*log10(abs(mxS));
mxSdeg=angle(mxS)*180/pi;


filename='twowires.snp';

[fid, msg] = fopen(filename,'w');
fprintf(fid,'!freq-unit param-type data-format keyword impedance-ohms\n');
fprintf(fid,'#GHz S DB R 50\n');
fprintf(fid,'!--------------\n');
fprintf(fid,'!Freq  DBSXX   AngSXX  DBSXX   AngSXX  DBSXX   AngSXX  DBSXX   AngSXX  \n');

for ii=1:Np
 freq=ff(ii)*1e-9;   
 
 for kk=1:4
  if kk==1    
   fprintf(fid,'%9.6f ',freq);
  else
   fprintf(fid,'           ');    
  end;
 
  fprintf(fid,'%7.3f  %7.3f  %7.3f  %7.3f  %7.3f  %7.3f  %7.3f  %7.3f\n',mxSdB(kk,1,ii),mxSdeg(kk,1,ii),mxSdB(kk,2,ii),mxSdeg(kk,2,ii),mxSdB(kk,3,ii),mxSdeg(kk,3,ii),mxSdB(kk,4,ii),mxSdeg(kk,4,ii));
 
 end; %end of cycle for kk
 
    
end;


fclose(fid);

fprintf('All S-parameters written to a file!\n');


